// (C) 2009 THQ Inc. Not for commercial use or redistribution without permission. All rights reserved.

#pragma once

#ifndef PATHPRECISE_ENVIRONMENT_H
#define PATHPRECISE_ENVIRONMENT_H

#include "Point2i.h"
#include <vector>

class TerrainMap;

typedef float PathGridCostType;

//
// Environment used when searching for a 'normal' path
//
class PathGridEnvironment
{
public:

	PathGridEnvironment(	const TerrainMap* terrainMap );

	PathGridCostType		Heuristic( const Point2i &start, const Point2i &goal, PathGridCostType gval ) const;

	void					GetNeighbours( const Point2i &parent_point, const Point2i &point, std::vector< Point2i > &neighbours, std::vector< PathGridCostType > &gcost ) const;

	bool					TestExitCondition( const Point2i &current_point, const Point2i &goal ) const;

	bool					ValidatePartialResult( const Point2i& /*current_point*/ ) const { return true; }

private:

	// assignment not defined
	const PathGridEnvironment& operator=( const PathGridEnvironment& );

protected:

	const TerrainMap*	m_terrainMap;
	const int			m_width;
	const int			m_height;
};


#endif
